			***********************

GWVA_WIND_THREAD_TIMER_MANAGEMENT:

	SUPEXEC GWVA_GET_200HZ_COUNTER

	move #GWVA_WIND_THREAD_MAX_PRIORITY_LVL,d7

.scan_all_priorities:
	cmp.b GWVA_WIND_THREAD_LAST_EXEC_PRIO,d7
	bne.s .no_stored_priority_to_check

	tst.l GWVA_WIND_THREAD_LAST_EXEC_THREAD
	bne.s .find_next_to_exec_same_priority

.no_stored_priority_to_check
.continue_after_same_prio_check:

	move #GWVA_WIND_THREAD_MAX_THREAD_NR-1,d6
	lea GWVA_WIND_THREAD_THREAD_INFO_TABLE,a0

.scan_all_threads_for_priority:
	cmp.b GWVA_THREAD_STRUCT_PRIORITY(a0),d7
	bne.s .not_this_priority
	tst.l GWVA_THREAD_STRUCT_EXEC_AD(a0)
	beq.s .no_thread_here

	bsr GWVA_WIND_THREAD_PRG_CMP_EXEC_IF_NEED	; a0=ptr thread =>d5=0 DID EXEC
	; d6/d7/a0 intacts
	tst d5
	beq.s .only_one_per_timer

.no_thread_here:
.not_this_priority:
	lea LENGTH_GWVA_THREAD_STRUCT(a0),a0
	dbf d6,.scan_all_threads_for_priority

	subq #1,d7
	bge.s .scan_all_priorities
	bra.s .nothing_execed_at_first_pass
	; pas la peine de scanner pour le temps rel ...

.only_one_per_timer:
	move.b d7,GWVA_WIND_THREAD_LAST_EXEC_PRIO
	move.l a0,GWVA_WIND_THREAD_LAST_EXEC_THREAD

.did_exec_one_same_prio:

	ifd OPT_GWVA_WIND_THREAD_REAL_TIME

	move #GWVA_WIND_THREAD_MAX_THREAD_NR-1,d7
	lea GWVA_WIND_THREAD_THREAD_INFO_TABLE,a0

.scan_all_threads_for_real_time:
	btst #GWVA_WIND_THREAD_FLAG_BIT_REAL_TIME,GWVA_THREAD_STRUCT_FLAGS(a0)
	beq.s .pas_flag_real_time
	tst.l GWVA_THREAD_STRUCT_EXEC_AD(a0)
	beq.s .no_thread_here2

	bsr GWVA_WIND_THREAD_PRG_CMP_EXEC_IF_NEED	; a0=ptr thread =>d5=0 DID EXEC
	; d6/d7/a0 intacts

.no_thread_here2:
.pas_flag_real_time
	lea LENGTH_GWVA_THREAD_STRUCT(a0),a0
	dbf d7,.scan_all_threads_for_real_time

	endc	; ifd OPT_GWVA_WIND_THREAD_REAL_TIME

.nothing_execed_at_first_pass:
	rts

	; Dans le cas thr1 thr2 thr1 thr3 avec thr2 & 3 same priority
.find_next_to_exec_same_priority:
	move.l GWVA_WIND_THREAD_LAST_EXEC_THREAD,a0

.scan_next_to_find:
.no_thread_here3:
.find_same_priority:
.i_did_not_exec_one:
	lea LENGTH_GWVA_THREAD_STRUCT(a0),a0

	tst.l GWVA_THREAD_STRUCT_EXEC_AD(a0)
	beq.s .no_thread_here3

	cmp.l #-1,GWVA_THREAD_STRUCT_EXEC_AD(a0)
	beq.s .end_of_thread_list

	cmp.b GWVA_THREAD_STRUCT_PRIORITY(a0),d7
	bne.s .find_same_priority

	bsr GWVA_WIND_THREAD_PRG_CMP_EXEC_IF_NEED	; a0=ptr thread =>d5=0 DID EXEC
	; d6/d7/a0 intacts
	tst d5
	bne.s .i_did_not_exec_one

	move.l a0,GWVA_WIND_THREAD_LAST_EXEC_THREAD
	; GWVA_WIND_THREAD_LAST_EXEC_PRIO est dj bon
	bra.s .did_exec_one_same_prio

.end_of_thread_list:
	clr.l GWVA_WIND_THREAD_LAST_EXEC_THREAD
	bra.s .continue_after_same_prio_check

GWVA_WIND_THREAD_PRG_CMP_EXEC_IF_NEED:
	; Entre : a0=ptr thread
	; Sortie : >d5=0 DID EXEC
	; Ne touche pas  d6/d7/a0

	move.l GWVA_CUR_200HZ_COUNTER,d0
	sub.l GWVA_THREAD_STRUCT_LAST_EXEC(a0),d0	; d0 =temps coul
	cmp.l GWVA_THREAD_STRUCT_FREQUENCY200(a0),d0
	blt.s .pas_encore_temps

	move.l GWVA_CUR_200HZ_COUNTER,GWVA_THREAD_STRUCT_LAST_EXEC(a0)

	save.l d6/d7/a0
	move.l GWVA_THREAD_STRUCT_EXEC_AD(a0),a1
	move.l GWVA_THREAD_STRUCT_PARAM_D0(a0),d0
	move.l GWVA_THREAD_STRUCT_PARAM_A0(a0),a0	; Attention : en dernier
	jsr (a1)
	SUPEXEC GWVA_GET_200HZ_COUNTER		; Impratif !
	load.l d6/d7/a0

	;  partir d'ici, ce thread peut trs bien avoir t effac
	; Il n'y a pas de moyen () priori) de savoir si la structure
	; sur laquelle je pointe ebn retour est celle du mme thread

	; donc OPT_GWVA_WIND_THREAD_STATS est incompatible avec un
	; fonctionnement pouss !

	ifd OPT_GWVA_WIND_THREAD_STATS

	move.l GWVA_CUR_200HZ_COUNTER,d0
	sub.l GWVA_THREAD_STRUCT_LAST_EXEC(a0),d0
	move.l d0,GWVA_THREAD_STRUCT_LAST_EXEC_DURATION(a0)

	cmp.l GWVA_THREAD_STRUCT_MIN_EXEC_DURATION(a0),d0
	bge.s .no_new_minimum
	move.l d0,GWVA_THREAD_STRUCT_MIN_EXEC_DURATION(a0)
.no_new_minimum:

	cmp.l GWVA_THREAD_STRUCT_MAX_EXEC_DURATION(a0),d0
	ble.s .no_new_maximum
	move.l d0,GWVA_THREAD_STRUCT_MAX_EXEC_DURATION(a0)
.no_new_maximum:

	add.l d0,GWVA_THREAD_STRUCT_SUMM_OF_EXEC_DURATION(a0)
	addq.l #1,GWVA_THREAD_STRUCT_NR_EXEC_TIMES(a0)

	endc

	clr d5
	rts

.pas_encore_temps:
	moveq #-1,d5
	rts

			***********************
GWVA_WIND_THREAD_CREATE:
	; Entre :
	; d0.l : valeur qui devra tre passe dans a0 lors de l'appel au thread fentre
	; d1.l : idem           ...                d0             ...
	;        mme s'ils ne sont pas utiliss d0/d1 doivent tre renseigns (pour
	;        dtection de la cration d'un mme thread 2 fois)
	; d2.l : adresse de la routine  xcuter avec un JSR !
	; Attention : on ne peut pas crer 2 fois un thread avec le mme d0/d1/d2
	; d3.l : frquence d'activation en multiples de 200 Hz (200 pour toutes les secondes)
	; d4.b : priorit de 0  GWVA_WIND_THREAD_MAX_PRIORITY_LVL (0 tant le moins prioritaire)
	;        un thread de priorit n+1 peut ne jamais tre activ si la somme des temps
	;        d'xcution des threads de priorit suprieure ou gale  n dpasse le temps
	;        la charge maximum du processeur. Dans ce cas, les threads de priorit n ne seront
	;        jamais activs tous  suivre (forcment il y aura entrelacement avec un thread
	;        de priorit >n) par contre ils seront xcuts une fois chacun.
	;        Exemple :
	;         THR1 : toutes les 10 ms prend 5 ms de temps d'excution, priorit 2
	;         THR2 : toutes les 10 ms prend 8 ms de temps d'excution, priorit 1
	;         THR3 : toutes les 10 ms prend 6 ms de temps d'excution, priorit 1
	;         THR4 : toutes les 10 ms prend 1 ms de temps d'excution, priorit 0
	;        L'ordre d'xcuction sera THR1 THR2 THR1 THR3 ... 
	;        Remarque : THR4 n'est jamais excut !
	; d5.b : flags optionnels
	;        GWVA_WIND_THREAD_FLAG_BIT_REAL_TIME : pour tester  chaque timer si on doit xcuter
	; Sortie :
	; d7.l : d7.l >= 0 => numro du handle, d7.l < 0 : erreur

	tst.l d2
	bne.s .routine_valide
	moveq #GWVA_ERROR_WIND_THREAD_BAD_PARAMS,d7
	rts
.routine_valide:

	lea GWVA_WIND_THREAD_THREAD_INFO_TABLE,a0

	move #GWVA_WIND_THREAD_MAX_THREAD_NR-1,d7
.search_same_thread:
	cmp.l GWVA_THREAD_STRUCT_EXEC_AD(a0),d2
	beq.s .same_routine
.not_same_a0:
.not_same_d0:
	lea LENGTH_GWVA_THREAD_STRUCT(a0),a0
	dbf d7,.search_same_thread
	bra.s .does_not_already_exist

.same_routine:
	cmp.l GWVA_THREAD_STRUCT_PARAM_A0(a0),d0
	bne.s .not_same_a0
	cmp.l GWVA_THREAD_STRUCT_PARAM_D0(a0),d1
	bne.s .not_same_d0

	moveq #GWVA_ERROR_WIND_THREAD_ALREADY_EXIST,d7
	rts

.does_not_already_exist:
	lea GWVA_WIND_THREAD_THREAD_INFO_TABLE,a0

	move #GWVA_WIND_THREAD_MAX_THREAD_NR-1,d7
.search_free_space:
	tst.l GWVA_THREAD_STRUCT_EXEC_AD(a0)
	beq.s .found_free_space
	lea LENGTH_GWVA_THREAD_STRUCT(a0),a0
	dbf d7,.search_free_space
	moveq #GWVA_ERROR_WIND_THREAD_NO_MORE_HANDLE,d7
	rts

.found_free_space:
	move.l d2,GWVA_THREAD_STRUCT_EXEC_AD(a0)
	move.l d0,GWVA_THREAD_STRUCT_PARAM_A0(a0)
	move.l d1,GWVA_THREAD_STRUCT_PARAM_D0(a0)
	move.l d3,GWVA_THREAD_STRUCT_FREQUENCY200(a0)
	move.b d4,GWVA_THREAD_STRUCT_PRIORITY(a0)
	move.b d5,GWVA_THREAD_STRUCT_FLAGS(a0)

	clr.l GWVA_THREAD_STRUCT_LAST_EXEC(a0)

	ifd OPT_GWVA_WIND_THREAD_STATS

	clr.l GWVA_THREAD_STRUCT_LAST_EXEC_DURATION(a0)
	move.l #$7fffffff,GWVA_THREAD_STRUCT_MIN_EXEC_DURATION(a0)
	clr.l GWVA_THREAD_STRUCT_MAX_EXEC_DURATION(a0)
	clr.l GWVA_THREAD_STRUCT_SUMM_OF_EXEC_DURATION(a0)
	clr.l GWVA_THREAD_STRUCT_NR_EXEC_TIMES(a0)

	endc

	move.l a0,d7
	sub.l #GWVA_WIND_THREAD_THREAD_INFO_TABLE,d7
	divu.w #LENGTH_GWVA_THREAD_STRUCT,d7
	rts
			***********************
GWVA_WIND_THREAD_DELETE:
	; Entre :
	; d0.w : numro du handle
	;        ou -1 pour tous les threads associs  a0.l pointeur sur une fentre
	; d1.l : pointeur sur une fentre si d0=-1
	; Sortie :
	; d7.w : 0=OK, <0 => erreur

	cmp.w #-1,d0
	beq.s .delete_all_threads_for_this_win

	tst d0
	bmi.s .bad_params
	cmp.w #GWVA_WIND_THREAD_MAX_THREAD_NR,d0
	bge.s .bad_params

	lea GWVA_WIND_THREAD_THREAD_INFO_TABLE,a0
	mulu #LENGTH_GWVA_THREAD_STRUCT,d0
	add.l d0,a0

	tst.l GWVA_THREAD_STRUCT_EXEC_AD(a0)
	beq.s .this_thread_doesnot_exist

	clr.l GWVA_THREAD_STRUCT_EXEC_AD(a0)

	clr d7
	rts

.this_thread_doesnot_exist:
	moveq #GWVA_ERROR_WIND_THREAD_DOESNOT_EXIST,d7
	rts

.bad_params:
	moveq #GWVA_ERROR_WIND_THREAD_BAD_PARAMS,d7
	rts

.delete_all_threads_for_this_win:
	lea GWVA_WIND_THREAD_THREAD_INFO_TABLE,a0

	move #GWVA_WIND_THREAD_MAX_THREAD_NR-1,d7
.search_window:
	tst.l GWVA_THREAD_STRUCT_EXEC_AD(a0)
	beq.s .no_thread_here
	cmp.l GWVA_THREAD_STRUCT_PARAM_A0(a0),d1
	bne.s .not_this_window

	clr.l GWVA_THREAD_STRUCT_EXEC_AD(a0)

.not_this_window:
.no_thread_here:
	lea LENGTH_GWVA_THREAD_STRUCT(a0),a0
	dbf d7,.search_window
	clr d7
	rts
			***********************
	ifd OPT_GWVA_WIND_THREAD_STATS

GWVA_WIND_THREAD_GET_INFO:
	; Entre :
	; d0.w : numro du handle
	; Sortie :
	; d0.l : dure de la denire xcution
	; d1.l : dure minimale d'xcution depuis sa naissance
	; d2.l : dure maximale d'xcution depuis sa naissance
	; d3.l : dure moyenne d'xcution depuis sa naissance

	lea GWVA_WIND_THREAD_THREAD_INFO_TABLE,a0
	mulu #LENGTH_GWVA_THREAD_STRUCT,d0
	add.l d0,a0

	move.l GWVA_THREAD_STRUCT_LAST_EXEC_DURATION(a0),d0
	move.l GWVA_THREAD_STRUCT_MIN_EXEC_DURATION(a0),d1
	move.l GWVA_THREAD_STRUCT_MAX_EXEC_DURATION(a0),d2
	move.l GWVA_THREAD_STRUCT_SUMM_OF_EXEC_DURATION(a0),d3
	move.l GWVA_THREAD_STRUCT_NR_EXEC_TIMES(a0),d4
	beq.s .no_div_by_0
	divu.l d4,d3
.no_div_by_0:
	rts

	endc
			***********************
