	output d:\assemble\visual41\samples\tutorial\clock\clock.acx

OPT_FULL_PATHNAMES
*OPT_DEBUG_IN_ACCESSORY_MODE
*OPT_DEBUG

	lea objet_application,a1

	include clock.def
	include visual41.s
	include clock.hs
	include clock.obj

	comment HEAD=7
	section TEXT

;---------------------------------------------------------------------------
	; Exemple de programme Visual Assembleur 4.1
	; Proprit : marche aussi bien en accessoire qu'en programme

	; Ce programme est un exemple de pendule numrique
	; qui se raffraichit touets les 2 secondes.

;---------------------------------------------------------------------------

initialisation_personnelle:
	tst GWVA_APP_OBJ_IS_ACC_PRG
	bne.s je_suis_lance_en_tant_que_programme

	rts

je_suis_lance_en_tant_que_programme:
ouverture_accessoire:
	lea objet_fenetre_clock,a0
	bsr GWVA_WIND_OBJ_PRG_CREATE_OPEN_ONE_WIND

	; mise a jour toutes les 2 secondes
	move.l #2000,objet_application+GWVA_APP_OBJ_COUNT
	rts

		;-----------------------------

fermeture_accessoire:
	lea objet_fenetre_clock,a0
	bsr GWVA_WIND_OBJ_PRG_TEST_IF_WIND_OPENED
	tst d7
	bmi.s actuellement_fermee

	; si on passe ici, c'est qu'un acc_close nous force  nous fermer
	; on met un timer en route, si dans 8 secondes il nous rapelle
	; c'est qu'on n'a pas t dgag de la mmoire : on se r-ouvrira
	; automatiquement  l'appel de la routine timer (cf. plus bas)
	btst #SELECTED,struct_bton_reopen+GWVA_FORM_BTON_OBJ_STATE+1
	beq.s option_reopen_non_engagee

	move.l #8000,objet_application+GWVA_APP_OBJ_COUNT
	bra.s saute_effacement_timer

option_reopen_non_engagee:
actuellement_fermee:

evenement_fenetre_clock_fermee:
evenement_ctrl_u_ctrl_q:
app_term_pour_mint:
	; plus aucun vnement timer !!
	clr.l objet_application+GWVA_APP_OBJ_COUNT

saute_effacement_timer:
	lea objet_fenetre_clock,a0
	bsr GWVA_WIND_OBJ_PRG_DELETE_ONE_WIND

	; il ne faut jamais sortir rlement si on est un ACCESSOIRE !!
	tst GWVA_APP_OBJ_IS_ACC_PRG
	bne VISUAL40_END

	rts

;---------------------------------------------------------------------------

evenement_timer:
	; c'est la r-ouverture automatique si timer et fentre ferme
	; alors c'est qu'on nous a for  nous fermer (acc_close)
	; donc on se r-ouvre
	lea objet_fenetre_clock,a0
	bsr GWVA_WIND_OBJ_PRG_TEST_IF_WIND_OPENED
	tst d7
	bmi ouverture_accessoire

	bsr met_a_jour_avec_heure_courante

	; je demande de redessiner une liste d'objets (d2=3)
	lea objet_fenetre_clock,a0
	lea liste_objets_a_redessiner,a1
	move.w #3,d2		; intrieur de la fentre
	bsr GWVA_FORM_WIND_OBJ_PRG_REDRAW_PART

	rts

met_a_jour_avec_heure_courante:
	move #FORM_CLOCK,d0
	move #TXT_TIME,d1
	bsr RETURN_TEXT_OBJ_IN_FORM_OBJ_PTR
	; j'ai ici dans a1 un pointeur sur le texte du champs TXT_TIME
	bsr GWVA_GET_FORMATED_TIME	; a1=ptr destination : "19:20:00"
	; je le remplis avec l'heure courante : bibliothque visual qui prend a1 en entre

	move #FORM_CLOCK,d0
	move #TXT_DATE,d1
	bsr RETURN_TEXT_OBJ_IN_FORM_OBJ_PTR
	; j'ai ici dans a1 un pointeur sur le texte du champs TXT_DATE
	bsr GWVA_GET_FORMATED_DATE	; a1=ptr destination : "29/06/1995"
	; je le remplis avec la date courante : bibliothque visual qui prend a1 en entre

	rts

;---------------------------------------------------------------------------

	section DATA

liste_objets_a_redessiner:
	dc.w TXT_TIME,1
	dc.w TXT_DATE,1
	dc.w -1

 END
